=== debian/changelog ===
intel-graphics-compiler2 (2.18.5-1) unstable; urgency=medium

  [ Pavel Androniychuk ]
  * New upstream release
  * rules: remove LTO strip
  * patches: add disable_warnings_as_errors.patch

  [ Timo Aaltonen ]
  * watch: Migrated to version 5.

 -- Timo Aaltonen <tjaalton@debian.org>  Mon, 27 Oct 2025 10:30:04 +0200
